'Compilable Example:
#Compile Exe "gbvisualget.exe"
#Dim All

#Debug Display On
#Debug Error On

%Unicode = 1
%UseWebBrowser = 1            ' // Use the WebBrowser control

$Ver = "1.03"

#Include "win32api.inc"
#Include Once "CWindow.inc"   ' // CWindow class
#Include "wininet.inc"

$SourceFile = "tempfiles\source.txt"
$BookMarkFile = "tempfiles\bookmarks.txt"
$HistoryFile  = "tempfiles\history.txt"

#Resource Icon logo "images\gbvisualget.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xfind "images\find.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xnext "images\next.ico"
#Resource Icon xfind "images\find.ico"
#Resource Icon xprevious "images\previous.ico"
#Resource Icon xsortup "images\sortascending.ico"
#Resource Icon xsortdown "images\sortdescending.ico"
#Resource Icon xzip "images\zip.ico"
#Resource Icon xmusic "images\music.ico"
#Resource Icon ximage "images\image.ico"
#Resource Icon xhtml "images\html.ico"
#Resource Icon xget "images\get.ico"
#Resource Icon xall "images\all.ico"
#Resource Icon xstop "images\stop.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xreload "images\reload.ico"
#Resource Icon xbrowser "images\browser.ico"
#Resource Icon xlist "images\list.ico"
#Resource Icon xsource "images\source.ico"
#Resource Icon xhome "images\home.ico"
#Resource Icon xengine "images\google.ico"
#Resource Icon xfile "images\selectfile.ico"
#Resource Icon xsize "images\size.ico"
#Resource Icon xhistory "images\history.ico"

#Resource Wave xalarm "files\alarm.wav"

Enum Equates Singular
   IDC_WebBrowser = 1000
   IDC_TextBox
   IDC_Toolbar
   IDC_ListView
   IDC_StatusBar

   IDT_Next
   IDT_Previous
   IDT_Stop
   IDT_Find
   IDT_Reload
   IDT_Download
   IDT_Zip
   IDT_Music
   IDT_HTML
   IDT_Images
   IDT_All
   IDT_LinkSize
   IDT_SelectFile
   IDT_OpenFolder
   IDT_ViewSource
   IDT_ShowBrowser
   IDT_HomeURL
   IDT_SearchURL
   IDT_History
   IDT_Settings
   IDT_Help

   IDM_Sep
   IDM_CheckAll
   IDM_UnCheckAll
   IDM_ReverseChecks
   IDM_CopyAll
   IDM_CopyChecked
   IDM_CopySelected
   IDM_OpenInBrowser
   IDM_RemoveSelected
   IDM_RemoveChecked
   IDM_RemoveAll
   IDM_DownloadSelected
   IDM_DownloadChecked
   IDM_DownloadAll
   IDM_ClearHistory
   IDM_ClearBookmarks
   IDM_AutoCreateFolder
   IDM_Links

   IDM_DLFolder
   IDM_SetHome
   IDM_Information
   IDM_UncheckOnDownload
   IDM_SetCurrentPageAsHome
   IDM_Test
   IDM_AddBookmark
   IDM_ShowBookmarks
   IDM_AllMeansAll
   IDM_SoundAlarm

   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete

   ID_Label
   ID_ProgressBar

   Zip = 1
   Music
   HTML
   Images
   AllLinks
End Enum

Global hDlg,hToolbar,hListView,hContext,hSettings,hHeader,hThread,hContextTxt As Dword
Global hFont,hFontTB,hImageListLV,hImageListTB,hBrowser,OldProc As Dword
Global URL, FontName As WStringZ * %Max_Path, History,BookMarks As String
Global SortDirection,FontSize, FontAttr, FileType, ShowBrowser, AutoCreateFolder As Long
Global SearchURL,DLFolder,HomeURL,ZipFiles,HTMLFiles,MusicFiles,ImageFiles,AllFiles As WStringZ * %Max_Path
Global LinkList() As String, AllMeansall,SoundAlarm,StopAction,UnCheckOnDownload As Long

Function PBMain
   Dialog New Pixels, 0, "gbVisualGet   v" + $Ver, , , 800, 1000, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateWebBrowser
   CreateListView
   CreateToolbar
   CreateStatusBar
   Dialog Show Modal hDlg, Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local pIWebBrowser2 As IWebBrowser2     'instance of the webbrowser control
   Local CGID_WebBrowser As Guid
   Local pDisp As IDispatch
   Local pCmdTarget As IOleCommandTarget
   Local vIn As Variant
   Local vOut As Variant
   Local tmp$, temp$
   Local w,h,iCount,i,iResult As Long
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr
   Local rc As Rect, LVData As NM_ListView

   Select Case CbMsg
      Case %WM_InitDialog
         Settings_INI "get"
         CreateTextBox
         BuildAcceleratorTable
         CreateSubFolders
         DataAction "get"   'bookmark and history
         Font New "Tahoma",10,0 To hFontTB
         Font New FontName, FontSize, FontAttr To hFont
         SetControlFonts
         SetMenusAndToolbar
         GoToURL

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDT_Download
               Thread Create DownloadFiles(0) To hThread
               Thread Close hThread To hThread

            Case %IDT_Stop
               StopAction = 1
            Case %IDT_OpenFolder
               ShellExecute(hDlg, "Open", DLFolder, $Nul, $Nul, %SW_Restore)

            Case %IDT_Zip    : FileType = %Zip      : UpdateLinkList
            Case %IDT_Music  : FileType = %Music    : UpdateLinkList
            Case %IDT_HTML   : FileType = %HTML     : UpdateLinkList
            Case %IDT_Images : FileType = %Images   : UpdateLinkList
            Case %IDT_All    : FileType = %AllLinks : UpdateLinkList

            Case %IDT_SelectFile
               SelectAndOpenFile
               UpdateLinkList

            Case %IDT_History
               LoadData History

            Case %IDM_AllMeansAll, %IDT_Settings
               AllMeansAll Xor= 1
               UpdateLinkList
               SetMenusAndToolbar

           Case %IDM_SoundAlarm
              SoundAlarm Xor= 1
              SetMenusAndToolbar

            Case %IDM_Links
               Select Case FileType
                  Case %Zip       : FileType = %Music
                  Case %Music     : FileType = %HTML
                  Case %HTML      : FileType = %Images
                  Case %Images    : FileType = %AllLinks
                  Case %AllLinks  : FileType = %Zip
               End Select
               UpdateLinkList
               SetMenusAndToolbar

            Case %IDT_ShowBrowser : ShowBrowser Xor= 1 : ResizeWindow
            Case %IDT_HomeURL
               URL = HomeURL
               Control Set Text hDlg, %IDC_TextBox, URL
               GotoURL

            Case %IDT_Previous : GoBack
            Case %IDT_Next     : GoForward

            Case %IDT_LinkSize :
               Thread Create GetLinkSizes(0) To hThread
               Thread Close hThread To hThread

            Case %IDT_Find
               pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
               CGID_WebBrowser = Guid$("{ED016940-BD5B-11CF-BA4E-00C04FD70816}")
               pDisp = pIWebBrowser2.Document
               pCmdTarget = pDisp
               pCmdTarget.Exec(CGID_WebBrowser, 1, 0, vIn, vOut)

            Case %IDT_Reload, %IdOk
               Control Get Text hDlg, %IDC_TextBox To URL
               GotoURL

            Case %IDT_ViewSource
               ViewSource

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbvisualget.htm"
               w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_SearchURL
               URL = SearchURL
               Control Set Text hDlg, %IDC_TextBox, URL
               GotoURL

            Case %IDM_DLFolder
               SelectDLFolder

            Case %IDM_AutoCreateFolder
               AutoCreateFolder Xor= 1
               SetMenusAndToolbar

            Case %IDM_SetHome
               Control Get Text hDlg, %IDC_TextBox To HomeURL

            Case %IDM_CheckAll      : CheckAll %True
            Case %IDM_UnCheckAll    : CheckAll %False
            Case %IDM_ReverseChecks : ReverseChecks

            Case %IDM_UnCheckOnDownload
               UnCheckOnDownload Xor= 1
               SetMenusAndToolbar

            Case %IDM_CopyAll
               Clipboard Reset
               temp$ = ""
               ListView Get Count hDlg, %IDC_ListView To iCount
               For i = 1 To iCount
                  ListView Get Text hDlg, %IDC_ListView, i, 3 To tmp$
                  temp$ += $CrLf + tmp$
               Next i
               temp$ = Trim$(temp$,$CrLf)
               If Len(temp$) Then Clipboard Set Text temp$

            Case %IDM_CopyChecked
               Clipboard Reset
               temp$ = ""
               ListView Get Count hDlg, %IDC_ListView To iCount
               For i = 1 To iCount
                  iResult = ListView_GetCheckState(hListView, i-1)
                  ListView Get Text hDlg, %IDC_ListView, i, 3 To tmp$
                  If iResult Then temp$ += $CrLf + tmp$
               Next i
               temp$ = Trim$(temp$,$CrLf)
               If Len(temp$) Then Clipboard Set Text temp$

            Case %IDM_CopySelected
               ListView Get Select hDlg, %IDC_ListView To iResult
               ListView Get Text hdlg, %IDC_ListView, iResult, 3 To temp$
               Clipboard Reset
               Clipboard Set Text temp$

            Case %IDM_RemoveSelected
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult = 0 Then Exit Function
               ListView Delete Item hdlg, %IDC_ListView, iResult
               ListView Get Count hDlg, %IDC_ListView To iCount
               If iCount = 0 Then Exit Function
               ListView Select hDlg, %IDC_ListView, Min(iCount,iResult)
               ListView_SetItemState hListView, Min(iCount,iResult)-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_RemoveChecked
               ListView Get Count hDlg, %IDC_ListView To iCount
               If iCount = 0 Then Exit Function
               For i = iCount To 1 Step -1
                  iResult = ListView_GetCheckState(hListView, i-1)
                  If iResult Then ListView Delete Item hDlg, %IDC_ListView, i
               Next i
               ListView Get Count hDlg, %IDC_ListView To iCount
               If iCount = 0 Then Exit Function
               ListView Select hDlg, %IDC_ListView, Min(iCount,iResult)
               ListView_SetItemState hListView, Min(iCount,iResult)-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_RemoveAll
               ListView Reset hDlg, %IDC_ListView

            Case %IDM_OpenInBrowser
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult = 0 Then Exit Function
               ListView Get Text hDlg, %IDC_ListView, iResult, 3 To temp$
               URL = temp$
               Control Set Text hDlg, %IDC_TextBox, URL
               GoToURL

            Case %IDM_Test
               Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, ""
               Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, ""
               ? "Bookmarks"+$CrLf + Bookmarks + $CrLf + $CrLf + "History" + $CrLf + History
'               URL = "http://www.garybeene.com/files/josetest.htm"
'               Control Set Text hDlg, %IDC_TextBox, URL
'               GoToURL

            Case %IDM_Information
               ListView Get Count hDlg, %IDC_ListView To iCount
               temp$ = "FileTypes:" + $Tab + $Tab + Choose$(FileType,"Zip","Music","HTML","Image","All") + " (" + Trim$(Str$(iCount)) + ")" + _
                    $CrLf + "Current URL:" + $Tab + URL + _
                    $CrLf + "Search URL:" + $Tab  + SearchURL + _
                    $CrLf + "Home Page:" + $Tab + HomeURL + _
                    $CrLf + $CrLf + "Download Folder: " + $CrLf + DLFolder
               MsgBox temp$, %MB_Ok + %MB_IconInformation,"Settings"

           Case %IDM_AddBookmark
              Control Get Text hDlg, %IDC_TextBox To temp$
              Bookmarks = temp$ + $CrLf + Bookmarks

           Case %IDM_ShowBookmarks
              LoadData Bookmarks

           Case %IDM_ClearBookmarks : Bookmarks = ""
           Case %IDM_ClearHistory   : History = ""

         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Next To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     @PTT.@lpszText = SetToolTips(Cb.NmId)
               End Select

            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select

            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %NM_DblClk
                     ListView Get Select hDlg, %IDC_ListView To iResult
                     If iResult = 0 Then Exit Function
                     ListView Get Text hDlg, %IDC_ListView, iResult, 3 To temp$
                     URL = temp$
                     GoToURL
                  Case %LVN_ColumnClick
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection = SortDirection Xor 1
                     If SortDirection Then
                        ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Ascend
                     Else
                        ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Descend
                     End If
                     SetHeaderIConsOnRight LVData.iSubItem
               End Select
         End Select

      Case %WM_ContextMenu
         Select Case Cb.WParam
            Case GetDlgItem(hDlg, %IDC_ListView)
               w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
               TrackPopupMenu hContext, %TPM_LeftAlign, w, h, 0, hDlg, ByVal 0   'put context menu where mouse is
               Function = 0 : Exit Function
         End Select

      Case %WM_Size : ResizeWindow

      Case %WM_Destroy
         Settings_INI "save"
         DataAction "save"
         SetWindowLong GetDlgItem(hDlg, %IDC_TextBox), %GWL_WNDPROC, OldProc
   End Select
End Function

Sub ResizeWindow
   Local w,h As Long
   If IsIconic(hDlg)=0 Then
      Dialog Get Client hDlg To w,h
      Control Set Size hDlg, %IDC_TextBox, w-20, 20
      If ShowBrowser Then
         Control Set Size hDlg, %IDC_ListView, 300, h-115
         Control Set Size hDlg, %IDC_WebBrowser,w-330, h-115
      Else
         Control Set Size hDlg, %IDC_ListView, w-20, h-115
         Control Set Size hDlg, %IDC_WebBrowser,0,0
      End If
   End If
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTxt, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc, hWnd, Msg, wParam, lParam)
End Function

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(11)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1    : ac(cc).cmd  = %IDT_Help         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_H     : ac(cc).cmd  = %IDT_HomeURL      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_T     : ac(cc).cmd  = %IDM_Links        : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_D     : ac(cc).cmd  = %IDT_Download     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_O     : ac(cc).cmd  = %IDT_OpenFolder   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_P     : ac(cc).cmd  = %IDT_Previous     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N     : ac(cc).cmd  = %IDT_Next         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_G     : ac(cc).cmd  = %IDT_Reload       : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_F     : ac(cc).cmd  = %IDT_Find         : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S     : ac(cc).cmd  = %IDT_ViewSource   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_B     : ac(cc).cmd  = %IDT_ShowBrowser  : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_Z     : ac(cc).cmd  = %IDM_Test         : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateWebBrowser
   Local pWindow As IWindow, pWBEvents As DWebBrowserEvents2Impl
   pWindow = Class "CWindow"
   pWBEvents = Class "CDWebBrowserEvents2"
   hBrowser = pWindow.AddWebBrowserControl(hDlg, %IDC_WEBBROWSER, "", pWBEvents, 320, 90, 600,350)
End Sub

Sub CreateListView
   Control Add ListView, hDlg, %IDC_ListView, "", 10,90,300,150, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_ClientEdge
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_CheckBoxes
   ListView Insert Column hDlg, %IDC_ListView, 1, "File Name", 200, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Size", 80, 0
   ListView Insert Column hDlg, %IDC_ListView, 3, "Full Path", 600, 0
   Control Handle hDlg, %IDC_ListView To hListView

   'create imagelist (sort icons)
   ImageList New Icon 24,24,24,3 To hImageListLV
   ImageList Add Icon hImageListLV, "xsortup"
   ImageList Add Icon hImageListLV, "xsortdown"

   'assign imagelist to header
   hHeader = ListView_GetHeader(hListView)
   Header_SetImageList hHeader, hImagelistLV

   Menu New PopUp To hContext
   Menu Add String, hContext, "Check All", %IDM_CheckAll, %MF_Enabled
   Menu Add String, hContext, "UnCheck All", %IDM_UnCheckAll, %MF_Enabled
   Menu Add String, hContext, "Reverse Checks", %IDM_ReverseChecks, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Copy Selected Link", %IDM_CopySelected, %MF_Enabled
   Menu Add String, hContext, "Copy Checked Links", %IDM_CopyChecked, %MF_Enabled
   Menu Add String, hContext, "Copy All Links", %IDM_CopyAll, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Download Selected Item", %IDM_DownloadSelected, %MF_Enabled
   Menu Add String, hContext, "Download Checked Items", %IDM_DownloadChecked, %MF_Enabled
   Menu Add String, hContext, "Download All Items", %IDM_DownloadAll, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Remove Selected Item", %IDM_RemoveSelected, %MF_Enabled
   Menu Add String, hContext, "Remove Checked Items", %IDM_RemoveChecked, %MF_Enabled
   Menu Add String, hContext, "Remove All Items", %IDM_RemoveAll, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Open Selected Item in Browser", %IDM_OpenInBrowser, %MF_Enabled
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "downloads") = %False Then MkDir Exe.Path$ + "downloads"
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
End Sub

Sub CreateStatusBar
   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 75,99999
End Sub

Sub CreateTextbox
   Control Add TextBox, hDlg, %IDC_TextBox, URL, 10,60,710,20
   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_TextBox), %GWL_WndProc, CodePtr(NewProc))
   Menu New PopUp To hContextTxt
   Menu Add String, hContextTxt, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextTxt, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextTxt, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextTxt, "Delete", %IDM_Delete,  %MF_Enabled
End Sub
Sub CreateToolbar
    ImageList New Icon 24,24,24,20 To hImageListTB
    ImageList Add Icon hImageListTB, "xsettings"  '1
    ImageList Add Icon hImageListTB, "xhelp"      '2
    ImageList Add Icon hImageListTB, "xnext"      '3
    ImageList Add Icon hImageListTB, "xprevious"  '4
    ImageList Add Icon hImageListTB, "xfind"      '5
    ImageList Add Icon hImageListTB, "xzip"       '6
    ImageList Add Icon hImageListTB, "xmusic"     '7
    ImageList Add Icon hImageListTB, "xhtml"      '8
    ImageList Add Icon hImageListTB, "ximage"     '9
    ImageList Add Icon hImageListTB, "xget"       '10
    ImageList Add Icon hImageListTB, "xall"       '11
    ImageList Add Icon hImageListTB, "xstop"      '12
    ImageList Add Icon hImageListTB, "xopen"      '13
    ImageList Add Icon hImageListTB, "xreload"    '14
    ImageList Add Icon hImageListTB, "xsource"    '15
    ImageList Add Icon hImageListTB, "xbrowser"   '16
    ImageList Add Icon hImageListTB, "xhome"      '17
    ImageList Add Icon hImageListTB, "xengine"    '18
    ImageList Add Icon hImageListTB, "xfile"      '19
    ImageList Add Icon hImageListTB, "xsize"      '20
    ImageList Add Icon hImageListTB, "xhistory"   '21

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListTB, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 10, %IDT_Download, %BTNS_Button, "Download"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12, %IDT_Stop, %BTNS_Button, "Stop"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Zip, %BTNS_CheckGroup, "Zip"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Music, %BTNS_CheckGroup, "Music"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_HTML, %BTNS_CheckGroup, "HTML"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9, %IDT_Images, %BTNS_CheckGroup, "Images"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11, %IDT_All, %BTNS_CheckGroup, "All"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Previous, %BTNS_Button, "Previous"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Next, %BTNS_Button, "Next"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 14, %IDT_Reload, %BTNS_Button, "Reload"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 17, %IDT_HomeURL, %BTNS_Button, "Home"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 20, %IDT_LinkSize, %BTNS_Button, "Size"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 18, %IDT_SearchURL, %BTNS_Button, "Search"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 19, %IDT_SelectFile, %BTNS_Button, "Local"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 21, %IDT_History, %BTNS_Button, "History"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Find, %BTNS_Button, "Find"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13, %IDT_OpenFolder, %BTNS_Button, "Folder"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 15, %IDT_ViewSource, %BTNS_Button, "Source"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 16, %IDT_ShowBrowser, %BTNS_Check, "Browser"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Help,  %BTNS_Button, "Help"

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Change DownLoad Folder", %IDM_DLFolder, %MF_Enabled
    Menu Add String, hSettings, "Set Current Page As Home Page", %IDM_SetHome, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Add Current Page To Bookmarks", %IDM_AddBookmark, %MF_Enabled
    Menu Add String, hSettings, "Show Bookmarks", %IDM_ShowBookmarks, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Clear Bookmarks", %IDM_ClearBookmarks, %MF_Enabled
    Menu Add String, hSettings, "Clear History", %IDM_ClearHistory, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "All Means All", %IDM_AllMeansAll, %MF_Enabled
    Menu Add String, hSettings, "Uncheck On Download", %IDM_UnCheckOnDownload, %MF_Enabled
    Menu Add String, hSettings, "AutoCreate Folder On Download", %IDM_AutoCreateFolder, %MF_Enabled
    Menu Add String, hSettings, "Play Sound When Download Complete", %IDM_SoundAlarm, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Display Settings", %IDM_Information, %MF_Enabled

End Sub

Sub SetControlFonts
   Control Set Font hDlg, %IDC_Toolbar, hFontTB
   Control Set Font hDlg, %IDC_ListView, hFont
   Control Set Font hDlg, %IDC_StatusBar, hFont
   Control Set Font hDlg, %IDC_TextBox, hFont
End Sub

Sub SetHeaderIconsOnRight(ByVal iActiveColumn As Integer)
   Local i As Integer, hdi As HD_ITEM
   For i = 0 To Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
      If i = iActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next
End Sub

Sub CheckAll(Flag As Long)
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView_SetCheckState hListView, i-1, Flag
   Next i
End Sub

Sub ReverseChecks
   Local i, iCount, iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      iResult = ListView_GetCheckState(hListView, i-1)
      If iResult = 0 Then   'not selected
         ListView_SetCheckState hListView, i-1, %True
      Else
         ListView_SetCheckState hListView, i-1, %False
      End If
   Next i
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Zip, IIf(FileType=%Zip,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Music, IIf(FileType=%Music,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_HTML, IIf(FileType=%HTML,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Images, IIf(FileType=%Images,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_All, IIf(FileType=%AllLinks,%TBState_Checked,0) Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowBrowser, IIf(ShowBrowser,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
    Menu Set State hSettings, ByCmd %IDM_AllMeansAll, AllMeansAll * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_UnCheckOnDownload, UnCheckOnDownload * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoCreateFolder, AutoCreateFolder * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_SoundAlarm, SoundAlarm * %MFS_Checked Or %MFS_Enabled
End Sub

Sub DataAction(Task$)
   If Task$ = "get" Then
      Open $BookmarkFile For Binary As #1
      Get$ #1, Lof(1), Bookmarks
      Close #1
      Open $HistoryFile For Binary As #1
      Get$ #1, Lof(1), History
      Close #1
   End If
   If Task$ = "save" Then
      Open $BookmarkFile For Binary As #1
      Put$ #1, Bookmarks
      SetEof #1
      Close #1
      Open $HistoryFile For Binary As #1
      Put$ #1, History
      SetEof #1
      Close #1
   End If
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1065", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "700", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ZipFiles", ".zip.rar.gz", ZipFiles, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MusicFiles", ".wav.mp3", MusicFiles, %Max_Path, INIFileName
      Getprivateprofilestring "All", "HTMLFiles", ".htm.html", HTMLFiles, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ImageFiles", ".ico.bmp.gif.jpg.png", ImageFiles, %Max_Path, INIFileName
      Getprivateprofilestring "All", "AllFiles", ".zip.rar.gz.wav.mp3.htm.html.ico.bmp.gif.jpg.png", AllFiles, %Max_Path, INIFileName
      Getprivateprofilestring "All", "DLFolder", Exe.Path$ + "downloads\", DLFolder, %Max_Path, INIFileName
      Getprivateprofilestring "All", "URL", "http://www.garybeene.com/sw/gbvisualget.htm", URL, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchURL", "http://www.google.com", SearchURL, %Max_Path, INIFileName
      Getprivateprofilestring "All", "HomeURL", "http://www.google.com", HomeURL, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "FileType", "5", temp, %Max_Path, INIFileName:  FileType = Val(temp)
      Getprivateprofilestring "All", "ShowBrowser", "1", temp, %Max_Path, INIFileName:  ShowBrowser = Val(temp)
      Getprivateprofilestring "All", "AllMeansAll", "0", temp, %Max_Path, INIFileName:  AllMeansAll = Val(temp)
      Getprivateprofilestring "All", "UnCheckOnDownload", "1", temp, %Max_Path, INIFileName:  UnCheckOnDownload = Val(temp)
      Getprivateprofilestring "All", "AutoCreateFolder", "0", temp, %Max_Path, INIFileName:  AutoCreateFolder = Val(temp)
      Getprivateprofilestring "All", "SoundAlarm", "1", temp, %Max_Path, INIFileName:  SoundAlarm = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "ZipFiles",ZipFiles, INIFileName
      WritePrivateProfileString "All", "MusicFiles",MusicFiles, INIFileName
      WritePrivateProfileString "All", "HTMLFiles",HTMLFiles, INIFileName
      WritePrivateProfileString "All", "ImageFiles",ImageFiles, INIFileName
      WritePrivateProfileString "All", "AllFiles",AllFiles, INIFileName
      WritePrivateProfileString "All", "DLFolder",DLFolder, INIFileName
      WritePrivateProfileString "All", "URL",URL, INIFileName
      WritePrivateProfileString "All", "SearchURL",SearchURL, INIFileName
      WritePrivateProfileString "All", "HomeURL",HomeURL, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "FileType", Str$(FileType), INIFileName
      WritePrivateProfileString "All", "ShowBrowser", Str$(ShowBrowser), INIFileName
      WritePrivateProfileString "All", "AllMeansAll", Str$(AllMeansAll), INIFileName
      WritePrivateProfileString "All", "UnCheckOnDownload", Str$(UnCheckOnDownload), INIFileName
      WritePrivateProfileString "All", "AutoCreateFolder", Str$(AutoCreateFolder), INIFileName
      WritePrivateProfileString "All", "SoundAlarm", Str$(SoundAlarm), INIFileName
   End If
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Download  : Function = "Download Checked Items"
      Case %IDT_Stop      : Function = "Stop Downloading Items"

      Case %IDT_Zip       : Function = "Zip Files " + ZipFiles
      Case %IDT_Music     : Function = "Music Files " + MusicFiles
      Case %IDT_HTML      : Function = "Web Pages " + HTMLFiles
      Case %IDT_Images    : Function = "Images " + ImageFiles
      Case %IDT_All       : Function = "All File Types " + AllFiles

      Case %IDT_Previous  : Function = "Previous Page"
      Case %IDT_Next      : Function = "Next Page"
      Case %IDT_Reload    : Function = "Reload URL"
      Case %IDT_HomeURL   : Function = "Got To Home Page (" + URL + ")"
      Case %IDT_LinkSize  : Function = "Get Size of Checked Items"
      Case %IDT_SearchURL : Function = "Got To Search Page (" + SearchURL + ")"
      Case %IDT_SelectFile: Function = "Select File to Display in Web Browser"

      Case %IDT_Find      : Function = "Open Find Dialog (Search URL)"
      Case %IDT_OpenFolder: Function = "Open Download Folder"
      Case %IDT_ViewSource : Function = "View Page Source"

      Case %IDT_ShowBrowser  : Function = "Show Web Browser"
      Case %IDT_Settings  : Function = "Settings"
      Case %IDT_Help      : Function = "Online Help"
   End Select
End Function

Sub GoForward
   On Error GoTo ForwardError
   Local pIWebBrowser2 As IWebBrowser2
   pIWebBrowser2 = OC_GetDispatch(hBrowser)
   pIWebBrowser2.GoForward
   Exit Sub
ForwardError:
End Sub

Sub GoBack
   On Error GoTo BackError
   Local pIWebBrowser2 As IWebBrowser2
   pIWebBrowser2 = OC_GetDispatch(hBrowser)
   pIWebBrowser2.GoBack
   Exit Sub
BackError:
End Sub

Sub ViewSource
   Local iResult As Long
   Open $SourceFile For Output As #1
   Print #1, GetText;
   Close #1
   iResult = Shell ("notepad.exe " + $SourceFile, 1)  'does not wait for it to close
End Sub

Function GetText() As String
   Local pIWebBrowser2 As IWebBrowser2     'instance of the webbrowser control
   Local pIHTMLDocument As IHTMLDocument2
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument = pIWebBrowser2.Document
   Function = pIHTMLDocument.body.innerHTML
End Function

Sub UpdateLinkList
   MousePtr 11
   GetLinkList
   LoadListView
   MousePtr 1
End Sub

Sub GetLinkList
   Local pIWebBrowser2 As IWebBrowser2
   Local pIHTMLDocument2 As IHTMLDocument2
   Local pIHTMLDocument3 As IHTMLDocument3
   Local Elems As IHTMLElementCollection
   Local E As IHTMLElement
   Local V As Variant, i,ACount,ICount As Long
   Local Img As IHTMLImgElement
   Local Flag As Long
   Local pDispatch As IDispatch

   'get needed references to current web page
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIHTMLDocument2 = pIWebBrowser2.Document
   pIHTMLDocument3 = pIHTMLDocument2

   'get "a" tag collection - hyperlinks
   Elems = pIHTMLDocument3.GetElementsByTagName("a")
   ACount = Elems.Length
   If ACount Then
      ReDim LinkList(ACount - 1) As String
      For i = 0 To Elems.Length - 1  'zero based element count
         Flag = 0 : V = i
         pIWebBrowser2 = Elems.item(ByVal V, ByVal V)
         E = pIWebBrowser2
         LinkList(i) = E.toString
      Next i
   End If

   'get "img" tag collection - hyperlinks
   Elems = pIHTMLDocument3.GetElementsByTagName("img")
   ICount = Elems.Length
   If ICount Then
      ReDim Preserve LinkList(ACount + ICount - 1) As String
      For i = 0 To Elems.Length - 1   'zero based element count
         pDispatch = Elems.item(i,1)
         Img = pDispatch
         LinkList(ACount+i) = Img.src
      Next i
   End If

End Sub

Sub LoadListView
   Local i,iPos,Flag As Long, tmp$

   'remove all links (clear ListView)
   ListView Reset hDlg, %IDC_ListView

   'put results into ListView
   For i = 0 To UBound(LinkList)
      If Trim$(LinkList(i)) = "" Then Iterate For
      Flag = 0
      'determine if link is of specified type
      Select Case FileType
         Case %Zip
            If InStr(ZipFiles,Right$(LinkList(i),3)) Then Flag = 1
         Case %Music
            If InStr(MusicFiles,Right$(LinkList(i),3)) Then Flag = 1
         Case %HTML
            If InStr(HTMLFiles,Right$(LinkList(i),3)) Then Flag = 1
         Case %Images
            If InStr(ImageFiles,Right$(LinkList(i),3)) Then Flag = 1
         Case %AllLinks
            If AllMeansAll Then
               Flag = 1
            Else
               If InStr(ZipFiles,Right$(LinkList(i),3)) Then Flag = 1
               If InStr(MusicFiles,Right$(LinkList(i),3)) Then Flag = 1
               If InStr(HTMLFiles,Right$(LinkList(i),3)) Then Flag = 1
               If InStr(ImageFiles,Right$(LinkList(i),3)) Then Flag = 1
            End If
      End Select

      If Flag Then
         'get short name
         iPos = InStr(-1,LinkList(i),"/")
         If iPos Then
            tmp$ = Mid$(LinkList(i),iPos+1)
            If Len(tmp$) = 0 Then
               tmp$ = LinkList(i)
               Replace "http://" With "" In tmp$
            End If
         End If
         ListView Insert Item hDlg, %IDC_ListView, 1, 0, tmp$
         ListView Set Text hDlg, %IDC_ListView, 1, 2, "-"
         ListView Set Text hDlg, %IDC_ListView, 1, 3, LinkList(i)
      End If
   Next i

   ListView Get Count hDlg, %IDC_ListView To i
   If i = 0 Then
      ListView Insert Item hDlg, %IDC_ListView, 1, 0, " No " + Choose$(FileType,"Zip","Music","HTML","Image") + " links found!"
      Statusbar Set Text hDlg, %IDC_Statusbar,  2, 0, " No " + Choose$(FileType,"Zip","Music","HTML","Image") + " links found!"
   Else
      Statusbar Set Text hDlg, %IDC_Statusbar, 2,0, $Spc + Choose$(FileType,"Zip","Music","HTML","Image") + " Links found: " + Str$(i)
   End If

End Sub

Sub SelectAndOpenFile
   Local filter$, startfile$, startfolder$, defaultext$, flags&, filevar$, countvar&
   startfolder$ = IIf$(IsFile(URL), PathName$(Path,URL), Exe.Path$)     'initial folder to be displayed
   If IsFile(URL) Then startfile$ = URL    'name to be used as initial selection
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, "Open Local File in Web Browser", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       URL = filevar$
       Control Set Text hDlg, %IDC_Textbox, URL
       GoToURL
    End If
End Sub

Sub GotoURL
   Local pIWebBrowser2 As IWebBrowser2     'instance of the webbrowser control
   Local vURL As Variant                    'argument for Navigate2 method
   Local temp$

   temp$ = URL
   If IsFile(temp$) Then
      Replace "\" With "/" In temp$
      temp$ = "file:///" + temp$
   End If

   vURL = temp$
   pIWebBrowser2 = OC_GetDispatch(hBrowser) 'reference to webbrowser control default interface
   pIWebBrowser2.Navigate2 vURL
End Sub

Class CDWebBrowserEvents2 As Event
   Interface DWebBrowserEvents2Impl $IID_DWebBrowserEvents2 As Event
      Inherit IDispatch

      Method DocumentComplete <259> ( ByVal pDisp As IDispatch, ByRef vURL As Variant)

         Local pIWebBrowser2 As IWebBrowser2
         Local pIHTMLDocument2 As IHTMLDocument2

         ' // Get a reference to the IWebBrowser2 interface
         pIWebBrowser2 = pDisp
         If IsNothing(pIWebBrowser2) Then Exit Method

         ' // Get a reference to the active document
         pIHTMLDocument2 = pIWebBrowser2.Document
         If IsNothing(pIHTMLDocument2) Then Exit Method

         'skip intermediate results
         If Variant$$(vURL) = "about:blank" Then Exit Method
'         If LCase$(Variant$$(vURL)) <> LCase$(URL) Then Exit Method

         'Extract file names, per settings
         If Len(Variant$$(vURL)) < %Max_Path Then History = Variant$$(vURL) + $CrLf + History
         Control Set Text hDlg, %IDC_TextBox, Variant$$(vURL)
         UpdateLinkList

         ' Release the interfaces
         pIWebBrowser2 = Nothing

      End Method

'      Method BeforeNavigate2 <250> ( _
'        ByVal pDisp As IDispatch _                         ' __in IDispatch* pDisp
'      , ByRef vURL As Variant _                            ' __in VARIANT* URL
'      , ByRef vFlags As Variant _                          ' __in VARIANT* Flags
'      , ByRef vTargetFrameName As Variant _                ' __in VARIANT* TargetFrameName
'      , ByRef vPostData As Variant _                       ' __in VARIANT* PostData
'      , ByRef vHeaders As Variant _                        ' __in VARIANT* Headers
'      , ByRef Cancel As Integer _                          ' __in_out VARIANT_BOOL* Cancel
'      )                                                    ' void
'
'         'skip intermediate results
''         If Variant$$(vURL) = "about:blank" Then Exit Method
''         If LCase$(Variant$$(vURL)) <> LCase$(URL) Then Exit Method
''         Control Set Text hDlg, %IDC_TextBox, Variant$$(vURL)
'
'      End Method

   End Interface
End Class

Function GetURLSite(tempURL$) As String
   Local iPosA, iPosB As Long
   iPosA = InStr(tempURL$,"//")
   If iPosA = 0 Then Exit Function
   iPosB = InStr(iPosA+2,tempURL$,"/")
   If iPosB = 0 Then Exit Function
   Function = Mid$(tempURL$, iPosA+2 To iPosB-1)
End Function

Thread Function DownloadFiles(ByVal x As Long) As Long
   Local i,iBars,iCount,dCount As Long, tmp$,temp$,tempURL$, tempFolder$

   Local URLSite$, URLFilePath$, Buffer$
   Local ServerFileSize&, AllBytes$, w,h,iPosA,iPosB As Long
   Local LocalFilePathZ As WStringZ*%Max_Path

   If AutoCreateFolder Then
      'create folder to use in this download cycle only
      tempFolder$ = DLFolder
      tmp$ = URL
      Replace Any ":/\" With "..." In tmp$
      tmp$ = Shrink$(tmp$,".")
      DLFolder = DLFolder + tmp$ + "\"
      MkDir DLFolder
   End If

   'cycle through each checked file
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      If StopAction Then StopAction = 0 : Statusbar Set Text hDlg, %IDC_StatusBar, 2,0, "Downloading stopped!" : Exit For
      If ListView_GetCheckState(hListView, i-1) = 0 Then Iterate For
      ListView Get Text hDlg, %IDC_ListView, i, 3 To tempURL$
      Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Please wait. Downloading " + tempURL$ + " ..."
'--------------------------------------------------------------------------------------------------------

      'local information
      temp$ = tempURL$
      Replace Any ":/\" With "..." In temp$
      temp$ = Shrink$(temp$,".")
      LocalFilePathZ = DLFolder + temp$    'location to put file on local PC

      If Len(LocalFilePathZ) > %Max_Path Then LocalFilePathZ = Right$(LocalFilePathZ,%Max_Path)
      If IsFile(LocalFilePathZ) Then Iterate For  'not download a local file

      'server information
      URLSite$ = GetURLSite(tempURL$) : If URLSite$ = "" Then Iterate For
      URLFilePath$ = tempURL$

      'clear the cache for the .new file
      DeleteURLCacheEntry(LocalFilePathZ)  '1 = success  clear the cache

      'before downloading, remove existing version, if it exists
      If IsFile(LocalFilePathZ) Then Kill LocalFilePathZ

      'Get file size to use in download display status
      Tcp Open "HTTP" At URLSite$ As #1 TimeOut 60000
      Tcp Print #1, "HEAD  " + URLFilePath$ + "  HTTP/1.0"
      Tcp Print #1, "" : Tcp Recv #1, 4096, Buffer$ : Tcp Close #1
      Buffer$ = Remain$(Buffer$, "Content-Length:")
      ServerFileSize& = Val(Extract$(Buffer$, $CrLf))

      If ServerFileSize& = 0 Then Iterate For   'can be a zero byte file or a folder name

      'Download the file
      Tcp Open "http" At URLSite$ As #1 TimeOut 60000   'connect
      If Err Then Beep : Iterate For
      Tcp Print #1, "GET " & URLFilePath$ & " HTTP/1.0"      'send the GET request
      Tcp Print #1, ""
      Do                                                              'get bytes until no more available
         Tcp Recv #1, 4096, Buffer$
         AllBytes$ = AllBytes$ + Buffer$
         iBars = Max(0,10 - 10 * Len(AllBytes$) / ServerFileSize&)
         Statusbar Set Text hdlg, %IDC_StatusBar, 1, 0, String$(iBars,"|")
      Loop While IsTrue Len(Buffer$) And IsFalse Err
      Tcp Close #1                     'done, close the connection

      If Len(AllBytes$) = 0 Then Iterate For  'no byte received
      ListView Set Text hDlg, %IDC_Listview, i,2,Format$(ServerFileSize,"###,###,##0")

      'Save the file, but first take off the HTTP header from the received bytes
      AllBytes$  = Remain$(AllBytes$, $CrLf + $CrLf)    'everything after the first pair of $crlf
      Open LocalFilePathZ For Binary As #1
      Put$ #1,AllBytes$
      Close #1
      Incr dCount  'file saved. increment download count
      If UnCheckOnDownload Then ListView_SetCheckState hListView, i-1, %False
'--------------------------------------------------------------------------------------------------------
   Next i
   If SoundAlarm And dCount Then Play Wave "xalarm"

   If AutoCreateFolder Then DLFolder = tempFolder$  'restore DLFolder to it's original value
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, ""
   Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Downloading complete. Files downloaded: " + Str$(dCount)
End Function

Thread Function GetLinkSizes(ByVal x As Long) As Long
   Local i,iCount,iPosA,iPosB,ServerFileSize As Long, URLSite$, URLFilePath$, Buffer$

   'cycle through each checked file
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      If StopAction Then StopAction = 0 : Statusbar Set Text hDlg, %IDC_StatusBar, 2,0, "Get Link Sizes stopped!" : Exit For
      If ListView_GetCheckState(hListView, i-1) = 0 Then Iterate For
      ListView Get Text hDlg, %IDC_ListView, i, 3 To URLFilePath$
      If IsFile(URLFilePath$) Then Iterate For
      Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Please wait. Getting size " + URLFilePath$ + " ..."
'--------------------------------------------------------------------------------------------------------
      'server information
      iPosA = InStr(URLFilePath$,"//")
      If iPosA = 0 Then Iterate For
      iPosB = InStr(iPosA+2,URLFilePath$,"/")
      If iPosB = 0 Then Iterate For
      URLSite$ = Mid$(URLFilePath$, iPosA+2 To iPosB-1)

      'Get file size to use in download display status
      Tcp Open "HTTP" At URLSite$ As #1 TimeOut 60000
      Tcp Print #1, "HEAD  " + URLFilePath$ + "  HTTP/1.0"
      Tcp Print #1, ""
      Tcp Recv #1, 4096, Buffer$
      Tcp Close #1
      Buffer$ = Remain$(Buffer$, "Content-Length:")
      ServerFileSize = Val(Extract$(Buffer$, $CrLf))

      ListView Set Text hDlg, %IDC_Listview, i,2,Format$(ServerFileSize,"###,###,##0")
'--------------------------------------------------------------------------------------------------------
   Next i
   Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Size retrieval complete!"
End Function

Sub SelectDLFolder
   Local title$, start$, flags&, folder$
   title$ = "Select Download Folder"
   start$ = DLFolder
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
   'folder$ is set to "" if Cancel/Escape is pressed
   If Len(folder$) Then DLFolder = folder$ + "\"
End Sub

Sub LoadData(ByVal S As String)
   Local i,iPos,Flag As Long, tmp$
   'remove all links (clear ListView)
   ListView Reset hDlg, %IDC_ListView
   'put browser histor into array

   Dim D(ParseCount(S,$CrLf)-1) As String
   Parse S, D(), $CrLf

   'put results into ListView
   For i = 0 To UBound(D)                  '0 position is empty
      If Len(D(i)) = 0 Then Iterate For
      'get short name
      iPos = InStr(-1,D(i),"/")
      If iPos Then
         tmp$ = Mid$(D(i),iPos+1)
         If Len(tmp$) = 0 Then
            tmp$ = D(i)
            Replace "http://" With "" In tmp$
         End If
      End If
      ListView Insert Item hDlg, %IDC_ListView, 1, 0, tmp$
      ListView Set Text hDlg, %IDC_ListView, 1, 2, "-"
      ListView Set Text hDlg, %IDC_ListView, 1, 3, D(i)
   Next i

   ListView Get Count hDlg, %IDC_ListView To i
   Statusbar Set Text hDlg, %IDC_Statusbar,  2, 0, "Items:  (" + Trim$(Str$(i)) + ")"
End Sub
